(* FUNCTIONS *)

fun Mtime() = ModelTime.time():time;

fun monday_january_1_2024() = 19723.0*day - 1.0*hour; (* STARTING FROM 1970-01-01*)
fun start_time() = monday_january_1_2024();

fun t2s(t) = Date.fmt "%Y-%m-%d %H:%M:%S" (Date.fromTimeLocal(Time.fromReal(t+start_time())));
fun i2s(i) = Int.toString(i);
fun p2s(p) = PRODUCT.mkstr(p);
fun ps2s(ps) = PRODUCTS.mkstr(ps);
fun ct2s(ct) = CUSTOMERTYPE.mkstr(ct);
fun pt2s(pt) = PAYMENTTYPE.mkstr(pt);
fun c2s(c) = COURIER.mkstr(c);

fun now() = t2s(Mtime());

fun exp(r) = exponential( 1.0 / r  );

fun select (lst, n) = 
        let
            fun random_pick(lst, 0, acc) = acc
                | random_pick(lst, n, acc) = 
                    let
                        val item = List.nth(lst, discrete(0, List.length(lst)-1))
                    in
                        random_pick(lst, n-1, item::acc)
                    end
        in
            random_pick(lst, n, [])
        end;

fun higherPriority((id1,ps1,ct1,pt1):CUSTOMERORDER, (id2,ps2,ct2,pt2):CUSTOMERORDER) = 
        if ct1 = Gold andalso ct2 = Silver then true else
            if ct1 = Gold andalso ct2 = Bronze then true else
                if ct1 = Silver andalso ct2 = Bronze then true else
                    false;

fun addprio(co:CUSTOMERORDER, []) = [co]
    | addprio(co:CUSTOMERORDER, co2::cos:CUSTOMERORDERS) = 
        if(higherPriority(co, co2)) then co::co2::cos
        else co2::addprio(co, cos);