(* EVENT LOG CREATION *)

val FILE = "./event_log";
val SEP = ";";
val HEADERS = [
		"timestamp",
		
		"type",
		"instance",
		"model",
		"action",
		
		"Order ID",
		"Products",
		"Customer type",
		"Payment type",
		
		"Replenishment ID",
		"Product",
		"Amount",
		
		"Shipment ID",
		"Courier",
		"Number of orders"
	];

val emptyOrderList = ["","","",""];
val emptyShipmentList = ["","",""];
val emptyReplenishmentList = ["","",""];

fun list2string([]) = ""|
	list2string(x::l) = x ^ (if l=[] then "" else SEP) ^ list2string(l);

fun create_log_file() = if logging = true then 
			let
				val file_id = TextIO.openOut(FILE^".csv")
				val _ = TextIO.output(file_id, list2string(HEADERS)) 
				val _ = TextIO.output(file_id, "\n")
			in
				TextIO.closeOut(file_id) 
			end
		else ();

fun write_record(l) = if logging = true then 
			let
				val file_id = TextIO.openAppend(FILE^".csv")
				val _ = TextIO.output(file_id, list2string(l))
				val _ = TextIO.output(file_id, "\n")
			in
				TextIO.closeOut(file_id) 
			end else ();

fun logo([]) = ()
	| logo((action, oid, ps, ct, pt)::rest) = (
			write_record([t2s(Mtime()), "Order", i2s(oid), "Order", action]^^[i2s(oid), ps2s(ps), ct2s(ct), pt2s(pt)]^^emptyReplenishmentList^^emptyShipmentList); 
			logo(rest)
		);

fun logr([]) = ()
	| logr((action, rid, p, n)::rest) = (
			write_record([t2s(Mtime()), "Replenishment", i2s(rid), "Replenishment", action]^^emptyOrderList^^[i2s(rid), p2s(p), i2s(n)]^^emptyShipmentList); 
			logr(rest)
		);

fun logs([]) = ()
	| logs((action, sid, c, n)::rest) = (
			write_record([t2s(Mtime()), "Shipment", i2s(sid), "Shipment", action]^^emptyOrderList^^emptyReplenishmentList^^[i2s(sid), c, i2s(n)]); 
			logs(rest)
		);